
#ifndef __MAILCONVERTER__
#include "MailConverter.h"
#endif



MailConverter::MailConverter()
	//: BApplication("application/x-vnd.MailConverter")
{
	printf("Started\n");
	//char *path = "/boot/home/Desktop/msgs/test";
	//ParseEmail(BEntry(path));
	//PostMessage(B_QUIT_REQUESTED);
}

MailConverter::~MailConverter()
{
	printf("Finished\n");
}

void MailConverter::RefsReceived(BMessage *message)
{
	entry_ref ref;
	BEntry entry;
	
	int i = 0;
	
	while (message->FindRef("refs", i++, &ref) == B_OK) {
		entry.SetTo(&ref);
		
		ParseEmail(entry);
	}
	//PostMessage(B_QUIT_REQUESTED);
}
void MailConverter::ParseEmail(BEntry &entry) {
	BFile file(&entry, B_READ_ONLY);
	off_t size;
	status_t stat = file.GetSize(&size);
	
	if (stat != B_OK) {
		printf("Getting size goofed\n");
		return;
	}
	
	char * buf = new char [size + 1];
	file.Read(buf, size);
	buf[size] = '\0';

	char *realStart = strstr(buf, "From: ");
	BString content;
	if (realStart != NULL) {
		content = buf;
	}
	else {
		printf("There is a heap o' crap at the start of the file\n");
		realStart = buf;
		while (realStart++ < (buf + size)) {
			*realStart = toascii(*realStart);
			if (//!iscntrl(*realStart)
				/*&& */(isalnum(*realStart) || ispunct(*realStart) || isspace(*realStart))) {
				content << *realStart;
			}
		}
		//content = realStart;
	}
	delete [] buf;

	if (content.FindFirst("\n") < 0) { // Mac
		// Mac outlook does not include \n in exported msgs
		// Win outlook does.
		content.ReplaceAll("\r", "\r\n"); // Make pretty
	}

	
	printf("[%s]\n", content.String());
	
	BString mail_to,
			mail_cc,
			mail_from,
			mail_name,
			mail_status,
			mail_date,
			mail_reply,
			mail_in_reply,
			mail_subject,
			mail_priority,
			mail_mime,
			mail_msg_id;

	// Easy to extract data
	ExtractAttribute(B_MAIL_TO, content, mail_to);
	ExtractAttribute(B_MAIL_CC, content, mail_cc);
	ExtractAttribute(B_MAIL_FROM, content, mail_from);
	ExtractAttribute(B_MAIL_REPLY, content, mail_reply);
	ExtractAttribute("In-Reply-To: ", content, mail_in_reply);
	ExtractAttribute(B_MAIL_SUBJECT, content, mail_subject);
	ExtractAttribute(B_MAIL_PRIORITY, content, mail_priority);
	ExtractAttribute("Mime-Version: ", content, mail_mime);
	ExtractAttribute("Message-Id: ", content, mail_msg_id);
	mail_msg_id.RemoveSet("<>"); // Trim surrounding pointy bits

	// Date information
	ExtractAttribute(B_MAIL_DATE, content, mail_date);
	time_t when = GetDateValue(mail_date);
	mail_date.Truncate(0);
	mail_date << when;
	printf("when = %s\n", mail_date.String());

	// Name and status
	mail_name = mail_from;
	int idx = mail_from.FindFirst("<");
	if (idx > 0) mail_name.Truncate(idx);
	mail_name.RemoveSet("<\">");
	if (mail_name.CountChars() == 0) mail_name = mail_from;
	mail_status = "New";
	
	// Fix reply-to.
	// Note: if reply addr is very long we probably picked up In-Reply-To instead
	if (mail_reply.Length() > 0 && mail_reply == mail_in_reply) {
		// in-reply-to puts guff in front of e-mail
		int dot = mail_reply.FindFirst(".");
		if (dot > 0) {
			mail_reply.Remove(0, dot + 1);
			mail_reply.Prepend("<");
			if (mail_reply.FindFirst(">") < 0) mail_reply.Append(">");
		}
	}
	else if (mail_reply.Length() == 0) {
		mail_reply = mail_from;
		idx = mail_reply.FindFirst("<");
		if (idx > 0) mail_reply.Remove(0, idx);
	}

	
	// Attatchment info
	int32 attach = content.FindFirst("Content-Type: multipart/mixed;");
	attach = (attach > 0 ? 1 : 0);

	/// Length infomation
	int32 totalLength = content.CountChars();
	int32 headerLength = content.FindFirst("\r\n\r") + strlen("\r\n\r");
	int32 contentLength = totalLength - headerLength;

	// Create output file
	BDirectory mailDir("/boot/home/mail/in");
	BString be_email_name;
	be_email_name << mail_name << "_" << when;
	
	// Create output file
	// name has format of: Sender_timestamp
	BEntry outentry;
	outentry.SetTo(&mailDir, be_email_name.String());
	while (outentry.Exists()) {
		when++; // Nudge the date up a bit to avoid name clash
		be_email_name.Truncate(0);
		be_email_name << mail_name << "_" << when;

		outentry.SetTo(&mailDir, be_email_name.String());
	}
	
	// The actual act of creation.  And then there was email.
	BFile out(&outentry, B_READ_WRITE | B_CREATE_FILE);
	if (out.InitCheck() != B_OK) return;
	if (!out.IsWritable()) {
		printf("Could not open file\n");
		return;
	}
	
	// Node for accessing the file's meta-data (ie. attributes)
	BNode node(&outentry);

	// Write all the attributes
	AddStrAttr(node, B_MAIL_ATTR_NAME, mail_name);
	AddStrAttr(node, B_MAIL_ATTR_SUBJECT, mail_subject);
	AddStrAttr(node, B_MAIL_ATTR_TO, mail_to);
	AddStrAttr(node, B_MAIL_ATTR_CC, mail_cc);
	AddStrAttr(node, B_MAIL_ATTR_FROM, mail_from);
	AddStrAttr(node, B_MAIL_ATTR_REPLY, mail_reply);
	AddStrAttr(node, B_MAIL_ATTR_STATUS, mail_status);
	AddStrAttr(node, B_MAIL_ATTR_PRIORITY, mail_priority);

	// Add slightly goofier attributes
	node.WriteAttr("MAIL:when", B_TIME_TYPE, 0, (void *)&when, sizeof(time_t));	
	node.WriteAttr(B_MAIL_ATTR_CONTENT, B_INT32_TYPE, 0, (void *)&contentLength, sizeof(int32));
	node.WriteAttr(B_MAIL_ATTR_HEADER, B_INT32_TYPE, 0, (void *)&headerLength, sizeof(int32));
	node.WriteAttr("MAIL:has_attachment", B_INT32_TYPE, 0, (void *)&attach, sizeof(int32));
	AddStrAttr(node, "MAIL:message-id", mail_msg_id);
	AddStrAttr(node, "MAIL:mime", mail_mime);

	// make type "text/email"
	BNodeInfo ninfo(&node);
	ninfo.SetType(B_MAIL_TYPE);

	// Now write the e-mail message content
	out.Write((void *)content.String(), content.Length());
}

time_t MailConverter::GetDateValue(BString val)
{
	// Format of time in e-mail:
	// Sun, 02 Apr 2000 14:22:53 -0700

	struct tm t; // Time structure
	t.tm_sec = 0;
	t.tm_min = 0;
	t.tm_hour = 0;
	t.tm_mday = 0; // Month day (1..31)
	t.tm_mon = 0; // Month (0..11)
	t.tm_year = 0; // Years after 1900
	t.tm_wday = 0; // Days after sunday (0..6)
	t.tm_yday = 0; // Day of year (0..365)
	t.tm_isdst = 0; // Daylight savings
	t.tm_gmtoff = 0; // GMT offset
	
	if (val.ICompare("Sun", 3) == 0) t.tm_wday = 0;
	else if (val.ICompare("Mon", 3) == 0) t.tm_wday = 1;
	else if (val.ICompare("Tue", 3) == 0) t.tm_wday = 2;
	else if (val.ICompare("Wed", 3) == 0) t.tm_wday = 3;
	else if (val.ICompare("Thu", 3) == 0) t.tm_wday = 4;
	else if (val.ICompare("Fri", 3) == 0) t.tm_wday = 5;
	else if (val.ICompare("Sat", 3) == 0) t.tm_wday = 6;
	else return 0;
	
	val.Remove(0, val.FindFirst(" ") + 1); // Trim upto first space
	printf("1 [%s]\n", val.String());
	sscanf(val.String(), "%d", &t.tm_mday);
	printf("Day = %d\n", &t.tm_mday);
	
	val.Remove(0, val.FindFirst(" ") + 1); // Trim to space
	printf("2 [%s]\n", val.String());
	if (val.ICompare("Jan", 3) == 0) t.tm_mon = 0;
	else if (val.ICompare("Feb", 3) == 0) t.tm_mon = 1;
	else if (val.ICompare("Mar", 3) == 0) t.tm_mon = 2;
	else if (val.ICompare("Apr", 3) == 0) t.tm_mon = 3;
	else if (val.ICompare("May", 3) == 0) t.tm_mon = 4;
	else if (val.ICompare("Jun", 3) == 0) t.tm_mon = 5;
	else if (val.ICompare("Jul", 3) == 0) t.tm_mon = 6;
	else if (val.ICompare("Aug", 3) == 0) t.tm_mon = 7;
	else if (val.ICompare("Sep", 3) == 0) t.tm_mon = 8;
	else if (val.ICompare("Oct", 3) == 0) t.tm_mon = 9;
	else if (val.ICompare("Nov", 3) == 0) t.tm_mon = 10;
	else if (val.ICompare("Dec", 3) == 0) t.tm_mon = 11;
	else {
		printf("Unrecognise month\n");
		return 0;
	}
	
	printf("Month %d\n", t.tm_mon);
	val.Remove(0, val.FindFirst(" ") + 1);
	printf("3 [%s]\n", val.String());
	
	sscanf(val.String(), "%d", &t.tm_year);
	t.tm_year -= 1900;
	printf("Years after 1900 %d (%d)\n", t.tm_year, t.tm_year + 1900);
	
	val.Remove(0, val.FindFirst(" ") + 1);
	printf("4 [%s]\n", val.String());

	sscanf(val.String(), "%d:%d:%d %3d", &t.tm_hour, &t.tm_min, &t.tm_sec, &t.tm_gmtoff);
	
	printf("HH:MM:SS GMT = %d:%d:%d %d\n", t.tm_hour, t.tm_min, t.tm_sec, t.tm_gmtoff);
	
	printf("Reconstructed time %s\n", asctime(&t));
	
	return mktime(&t);
}

/*
 * This method parses email content for a delimiter of a specific name.
 */
int MailConverter::ExtractAttribute(const char *name, BString &content, BString &value)
{
	int index = content.IFindFirst(name);
	value.Truncate(0, false);
	if (index >= 0) {
		int valOffset = index + strlen(name);
		printf("Found %s at %d\n", name, index);
		int end = content.FindFirst("\r", index);
		if (end > index) content.CopyInto(value, valOffset, end - valOffset);
		value.RemoveSet("\r\n");
		printf("Value is [%s]\n", value.String());
		return B_OK;
	}
	return B_ERROR;
}
/*
 * Write a string-type attribute to a file's metadata
 */
int MailConverter::AddStrAttr(BNode &node, const char *attr_name, const BString &value)
{
	if (value.Length() > 0) {
		printf("%s: ", attr_name); fflush(stdout);
		node.WriteAttr(attr_name, B_STRING_TYPE, 0, (void *)value.String(), value.Length()+1);
		printf("written\n"); fflush(stdout);
		return B_OK;
	}
	return B_ERROR;
}